"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.register = void 0;
const findReferences = require("./references");
function register({ sourceFiles, getTsLs }) {
    const _findReferences = findReferences.register(arguments[0]);
    return (codeLens, showReferencesCommand) => {
        var _a, _b, _c;
        // @ts-expect-error
        const data = codeLens.data;
        const tsLs = getTsLs(data.lsType);
        const doc = data.uri ? (_b = (_a = sourceFiles.get(data.uri)) === null || _a === void 0 ? void 0 : _a.getTextDocument()) !== null && _b !== void 0 ? _b : tsLs.__internal__.getTextDocument(data.uri) : undefined;
        const tsDoc = data.tsUri ? tsLs.__internal__.getTextDocument(data.tsUri) : undefined;
        const sourceFile = data.uri ? sourceFiles.get(data.uri) : undefined;
        if (data.uri && doc && tsDoc && data.offset !== undefined && data.tsOffset !== undefined) {
            const pos = doc.positionAt(data.offset);
            const vueReferences = _findReferences(data.uri, pos);
            let references = vueReferences;
            if (sourceFile) {
                let isCssLocation = false;
                for (const cssSourceMap of sourceFile.getCssSourceMaps()) {
                    if (cssSourceMap.getMappedRange(pos)) {
                        isCssLocation = true;
                    }
                }
                if (isCssLocation) {
                    references = vueReferences === null || vueReferences === void 0 ? void 0 : vueReferences.filter(ref => {
                        if (ref.uri === data.uri) {
                            for (const cssSourceMap of sourceFile.getCssSourceMaps()) {
                                if (cssSourceMap.getMappedRange(ref.range.start, ref.range.end)) {
                                    return false;
                                }
                            }
                        }
                        return true;
                    });
                }
                else {
                    references = vueReferences === null || vueReferences === void 0 ? void 0 : vueReferences.filter(ref => {
                        if (ref.uri === data.uri) {
                            return false;
                        }
                        return true;
                    });
                }
            }
            else {
                references = vueReferences === null || vueReferences === void 0 ? void 0 : vueReferences.filter(ref => {
                    if (ref.uri === data.uri) {
                        return false;
                    }
                    return true;
                });
            }
            const referencesCount = (_c = references === null || references === void 0 ? void 0 : references.length) !== null && _c !== void 0 ? _c : 0;
            codeLens.command = {
                title: referencesCount === 1 ? '1 reference' : `${referencesCount} references`,
                command: showReferencesCommand !== null && showReferencesCommand !== void 0 ? showReferencesCommand : '',
                arguments: [data.uri, codeLens.range.start, vueReferences],
            };
        }
        return codeLens;
    };
}
exports.register = register;
//# sourceMappingURL=referencesCodeLensResolve.js.map