import { CodeGen } from '@volar/code-gen';
import * as shared from '@volar/shared';
import type { parseScriptSetupRanges } from '@volar/vue-code-gen/out/parsers/scriptSetupRanges';
import { Ref } from '@vue/reactivity';
import type * as css from 'vscode-css-languageservice';
import { TextDocument } from 'vscode-languageserver-textdocument';
import { ITemplateScriptData, LanguageServiceContext } from '../types';
import * as SourceMaps from '../utils/sourceMaps';
export declare function useSfcTemplateScript(vueUri: string, vueDoc: Ref<TextDocument>, template: Ref<shared.Sfc['template']>, scriptSetup: Ref<shared.Sfc['scriptSetup']>, scriptSetupRanges: Ref<ReturnType<typeof parseScriptSetupRanges> | undefined>, styles: Ref<shared.Sfc['styles']>, templateScriptData: ITemplateScriptData, styleDocuments: Ref<{
    textDocument: TextDocument;
    stylesheet: css.Stylesheet | undefined;
    links: {
        textDocument: TextDocument;
        stylesheet: css.Stylesheet;
    }[];
    module: string | undefined;
    scoped: boolean;
}[]>, styleSourceMaps: Ref<SourceMaps.CssSourceMap[]>, templateData: Ref<{
    sourceLang: 'html' | 'pug';
    html: string;
    htmlToTemplate: (start: number, end: number) => number | undefined;
} | undefined>, sfcTemplateCompileResult: ReturnType<(typeof import('./useSfcTemplateCompileResult'))['useSfcTemplateCompileResult']>, sfcStyles: ReturnType<(typeof import('./useSfcStyles'))['useSfcStyles']>['textDocuments'], scriptLang: Ref<string>, context: LanguageServiceContext): {
    templateCodeGens: import("@vue/reactivity").ComputedRef<{
        codeGen: CodeGen<SourceMaps.TsMappingData>;
        formatCodeGen: CodeGen<SourceMaps.TsMappingData>;
        cssCodeGen: CodeGen<undefined>;
        tagNames: Record<string, {
            rawComponent: string;
            slotsComponent: string;
            baseProps: string;
            emit: string;
            slots: string;
            events: Record<string, string>;
            offsets: number[];
        }>;
        attrNames: Set<string>;
    } | undefined>;
    sourceMap: import("@vue/reactivity").ComputedRef<SourceMaps.TsSourceMap | undefined>;
    textDocument: Ref<shared.TextDocument | undefined>;
    textDocumentForFormatting: Ref<shared.TextDocument | undefined>;
    sourceMapForFormatting: import("@vue/reactivity").ComputedRef<SourceMaps.TsSourceMap | undefined>;
    teleportSourceMap: Ref<SourceMaps.TeleportSourceMap | undefined>;
    cssTextDocument: import("@vue/reactivity").ComputedRef<{
        textDocument: shared.TextDocument;
        stylesheet: css.Stylesheet;
        links: never[];
        module: boolean;
        scoped: boolean;
    } | undefined>;
    cssSourceMap: import("@vue/reactivity").ComputedRef<SourceMaps.CssSourceMap | undefined>;
    update: () => void;
};
